Ruby - Bug #16116

ruby2.6.3(x86/x64) use win32ole could not new Object, return 0x80070057
08/22/2019 12:01 PM - whdukewu (Kewu DU)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.6.3p62 (2019-04-16 revision Backport: 2.5: UNKNOWN, 2.6: UNKNOWN
67580) [i386-mingw32]

Description

| build a RubyTest.dll by C#, In ruby2.2, | could use WIN320LE.new to create ole object, but in the same system under ruby2.6.3, it
failed to create ole object by WIN320OLE.new, is there any different between ruby 2.2 and ruby 2.6.3 in WIN320OLE?

OS: Win7 Profressional SP1 64bit

/7 Ruby 2.6.3 use WIN320LE failed to load dll /71711111
C:\Ruby26\bin>ruby -v
ruby 2.6.3p62 (2019-04-16 revision 67580) [i386-mingw32]

C:\Ruby26\bin>irb

irb(main):001:0> require 'win32ole’'

=> true

irb(main):002:0> WIN320LE.new('RubyTest.DIITest')

Traceback (most recent call last):

6: from C:/Ruby26/bin/irb.cmd:31:in <main>' 5: from C:/Ruby26/bin/irb.cmd:31:in load'

4: from C:/Ruby26/lib/ruby/gems/2.6.0/gems/irb-1.0.0/exe/irb:11:in <top (require 3: from (irb):2 2: from (irb):2:in new'
1: from (irb):2:in initialize' WIN320OLERuntimeError (failed to create WIN320LE object from RubyTest.DlITest')
**  HRESULT error code:0x80070057

The parameter is incorrect.™

irb(main):003:0>

c:\TestTools\impellenlib\Ruby\bin>ruby -v
ruby 2.2.6p396 (2016-11-15 revision 56800) [i386-mingw32]

/1 Ruby 2.2 use WINS20LE success load dll /777171117
c:\TestTools\impellenlib\Ruby\bin>irb

irb(main):001:0> require 'win32ole’'

=> true

irb(main):002:0> WIN320LE.new('RubyTest.DIITest')
@@@DIITest Constructor

=> #WIN320OLE:0x7418b68

irb(main):003:0>

History

#1 - 06/10/2020 07:59 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Feedback

It's hard to debug issues like this without having a self contained reproducible example. Can you provide a self contained reproducible example
showing the problem? Basic testing of WIN320LE using Ruby 2.6 on Windows 10 with the examples in the documentation (which use
Excel.Application) work fine, so this doesn't appear to be a general problem with WIN320LE.

#2 - 07/13/2020 05:03 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Feedback to Closed

#3 - 12/04/2020 08:12 AM - whdukewu (Kewu DU)

finally we solve this problem by this way:

1. add mscoree.dll to windows registry key ** \HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\KnownDLLs** **
2. restart windows systems
then we can load dll files in ruby 2.6.3.

The dll developed by C# language depend mscoree.dll, in ruby2.2, windows system can search the mscoree.dll successfully, but in ruby2.6, it fails to
search mscoree.dll when call the WIN320OLE.new method, CoCreatelnstance function in win32ole.c returns 0x80070057, this indicates some
parameter is invalid, we don't know why this happen, even we set RUBY_DLL_PATH, it failed to load C# dll files.

#4 - 12/04/2020 12:23 PM - larskanis (Lars Kanis)

@whdukewu Can you provide a reproducible example of such a C# DLL? We got several issues with WIN320LE at RubylInstaller, but | wasn't able to
reproduce them - mostly because they depend on some proprietary COM DLLs. Your use case seems easy enough to be usable for investigation of
the issue.

#5 - 08/11/2021 07:59 AM - krolchatina (Dmitry Kirillov)
- File ClassLibraryForRuby.zip added

| have the same issue with Ruby 3.0.2 and .NET COM assemblies. The problem seems to be related to how the assembly is registered: If
InprocServer32/Default contains the full path to mscoree.dll (C:\Windows\system32\mscoree.dll) there is no problem with WIN320LE.new
If InprocServer32/Default contains only mscoree.dll (which seems to be the default nowadays), WIN320OLE.new fails with "HRESULT error
code:0x80070057 / The parameter is incorrect.”

| created a small assembly that demonstrates the problem. The assembly can be built using "dotnet build" command.

Files

ClassLibraryForRuby.zip 1.55 KB 08/11/2021 krolchatina (Dmitry Kirillov)
https://github.com/oneclick/rubyinstaller2/search?q=win32ole&type=issues
